%define name roxen
%define version 1.3.122
%define release 8mdk

Name: %{name} 
Summary: Roxen is a powerfull and easy to adminstrate webserver 
Version: %{version}
Release: %{release}
Source0: http://www.roxen.com/download/source/roxen_1.3.122-0.6-40bit.tar.bz2
Source1: Global_Variables
Source2: configuration.template
Source3: initd.template
Source4: frontend1.gif
Source5: frontend2.gif
Source6: mandrake.gif
Source7: redhat.gif
Source8: index.html.template
Patch0: ftp://ftp.roxen.com/pub/roxen/patches/roxen_1.3.122-wizard.pike.patch
Patch1: roxen_1.3.122-vaarg.patch.bz2
Group: System/Servers
BuildRequires: gdbm-devel gmp-devel libjpeg-devel postgresql readline-devel libtermcap-devel zlib-devel
URL: http://www.ls-la.net/roxen/
BuildRoot: %{_tmppath}/%{name}-root
Copyright: GPL
Prefix: /usr

%description
Roxen is a webserver, based at the language Pike. It offers full administration
using a WWW-interface, SSL-support, adding/deleting/updating of internal mo-
dules without recompiling, shutdown/restart without superuser-privileges and a 
lot of usefull additional modules like Email-frontends, generation of GIFs,
diagrams, counter etc. Once you use it, you will love it.


%package devel
Summary: Devel file for Roxen webserver
Copyright: GPL
Group: Development/C

%description devel
Roxen is a webserver, based at the language Pike. It offers full administration
using a WWW-interface, SSL-support, adding/deleting/updating of internal mo-
dules without recompiling, shutdown/restart without superuser-privileges and a 
lot of usefull additional modules like Email-frontends, generation of GIFs,
diagrams, counter etc. Once you use it, you will love it.

%prep
rm -rf $RPM_BUILD_ROOT

%setup -q -n roxen_1.3.122

# Patching wizard.pike - Patch0
cd server/base_server
%patch0 
cd ../..
%patch1 -p1 -b .vararg

%build
%configure
make

%install
%makeinstall

# Define some directories
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
mkdir -p $RPM_BUILD_ROOT/var/log/roxen
mkdir -p $RPM_BUILD_ROOT/etc/roxen
mkdir -p $RPM_BUILD_ROOT/home/roxen/html
mkdir -p $RPM_BUILD_ROOT/home/roxen/cgi-bin
mkdir -p $RPM_BUILD_ROOT/usr/doc/roxen-1.3.122/pdf
mkdir -p $RPM_BUILD_ROOT/usr/doc/roxen-1.3.122/html
mkdir -p $RPM_BUILD_ROOT/home/roxen/html/welcome

# Set up logging-directory
cd $RPM_BUILD_ROOT%{prefix}/roxen
rm -fr logs
ln -s /var/log/roxen logs
cd $RPM_BUILD_ROOT/etc/roxen
rm -f logs
ln -s /var/log/roxen logs

# Set up configuration-directory
mv -f $RPM_BUILD_ROOT%{prefix}/roxen/configurations \
   $RPM_BUILD_ROOT/etc/roxen/configurations
cd $RPM_BUILD_ROOT%{prefix}/roxen/server
ln -s /etc/roxen/configurations configurations

# Install PDF-documentation
mv -f $RPM_BUILD_ROOT%{prefix}/roxen/server/manual/pdf/* \
   $RPM_BUILD_ROOT/usr/doc/roxen-1.3.122/pdf
# Install HTML-documentation
mv -f $RPM_BUILD_ROOT%{prefix}/roxen/server/manual/parsed_challenger/* \
   $RPM_BUILD_ROOT/usr/doc/roxen-1.3.122/html
# Delete the unwanted stuff to save disk-space
rm -rf $RPM_BUILD_ROOT%{prefix}/roxen/server/manual


# Init.d-script
cp -f %{SOURCE3}     $RPM_BUILD_ROOT/etc/rc.d/init.d/roxen
#chown root:root      $RPM_BUILD_ROOT/etc/rc.d/init.d/roxen
chmod u=rwx,g=rx,o=r $RPM_BUILD_ROOT/etc/rc.d/init.d/roxen

# Install welcome-HTML-page including graphics
cp -f %{SOURCE4}	 $RPM_BUILD_ROOT/home/roxen/html/welcome/
cp -f %{SOURCE5}	 $RPM_BUILD_ROOT/home/roxen/html/welcome/
cp -f %{SOURCE6}	 $RPM_BUILD_ROOT/home/roxen/html/welcome/
cp -f %{SOURCE7}     $RPM_BUILD_ROOT/home/roxen/html/welcome/
#chown root:root      $RPM_BUILD_ROOT/home/roxen/html/welcome/*
chmod u=rw,g=r,o=r   $RPM_BUILD_ROOT/home/roxen/html/welcome/*

# To include the templates :(
mkdir -p $RPM_BUILD_ROOT/etc/roxen/configurations/
cp -f %{SOURCE1} \
	$RPM_BUILD_ROOT/etc/roxen/configurations/Global_Variables.template
cp -f %{SOURCE2} \
	$RPM_BUILD_ROOT/etc/roxen/configurations/Host.template
cp -f %{SOURCE8} \
    $RPM_BUILD_ROOT/etc/roxen/index.html.template

# Make the Roxen-Starter easier to find in ps
cd $RPM_BUILD_ROOT%{prefix}/roxen/server
ln start RunRoxen

# Correct #!/usr/local/bin/pike lines to get dependencies working :(
find $RPM_BUILD_ROOT -type f |xargs perl -p -i -e  \
      's/\#\!\/usr\/local\/bin\/pike/\#\!\/usr\/bin\/pike-roxen/'
# Correct 'Roxen's install prefix' within pike-roxen
cat $RPM_BUILD_ROOT/usr/bin/pike-roxen | \
	sed -e "s/\/var\/tmp\/roxen-buildroot\/\/usr\/roxen\/server\//\/usr\/roxen\/server\//" \
	> $RPM_BUILD_ROOT/usr/bin/pike-roxen.new
mv -f $RPM_BUILD_ROOT/usr/bin/pike-roxen.new $RPM_BUILD_ROOT/usr/bin/pike-roxen

cd $RPM_BUILD_ROOT
# First, remove TAGS files, otherwise spec-helper will make troubles

find . -type f -name "TAGS" -exec /bin/rm -f '{}' \;
find $RPM_BUILD_ROOT -type d -name CVS|xargs rm -fr
find $RPM_BUILD_ROOT -type f -name .cvsignore|xargs rm -f

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,0755)
/usr/roxen/BUGS
/usr/roxen/CHANGES
/usr/roxen/COPYING
/usr/roxen/COPYING.int
/usr/roxen/ChangeLog.gz
/usr/roxen/ChangeLog.rxml.gz
/usr/roxen/GPL
/usr/roxen/INSTALLING
/usr/roxen/INSTALLING.BIN
/usr/roxen/INSTALLING.CD
/usr/roxen/README
/usr/roxen/VERSION
#/usr/roxen/server/lib/pike/modules/Crypto
/usr/roxen/server/lib/pike/modules/*.pmod
/usr/roxen/server/lib/pike/master.pike.in
/usr/roxen/server/lib/pike/master.pike
/usr/roxen/server/configvar
/usr/roxen/server/demo_certificate.pem
/usr/roxen/server/install
/usr/roxen/server/mkdir
/usr/roxen/server/start
/usr/roxen/server/testca.pem
/usr/roxen/server/base_server/*.pike
/usr/roxen/server/base_server/struct
/usr/roxen/server/base_server/config
/usr/roxen/server/bin
/usr/roxen/server/config_actions/*
/usr/roxen/server/etc/config.40bit.html
/usr/roxen/server/etc/config.html
/usr/roxen/server/etc/config.int.html
/usr/roxen/server/etc/errordata
/usr/roxen/server/etc/extensions
/usr/roxen/server/etc/restart.html
/usr/roxen/server/etc/rgb.dat
/usr/roxen/server/etc/roxen_hilfe.pike
/usr/roxen/server/etc/roxen_master.pike
/usr/roxen/server/etc/shutdown.html
/usr/roxen/server/etc/supports
/usr/roxen/server/etc/upgrade_servers
/usr/roxen/server/etc/welcome.html
/usr/roxen/server/etc/classes/jsdk.jar
/usr/roxen/server/etc/classes/roxen_servlet.jar
/usr/roxen/server/etc/digits
/usr/roxen/server/etc/env.d/informix.pike
/usr/roxen/server/etc/env.d/oracle.pike
/usr/roxen/server/etc/modules/Dims.pmod
/usr/roxen/server/etc/modules/GText.pmod
/usr/roxen/server/etc/modules/PDB.pmod
/usr/roxen/server/etc/modules/Servlet.pmod
/usr/roxen/server/etc/modules/RoxenRPC.pmod/Client.pike
/usr/roxen/server/etc/modules/RoxenRPC.pmod/Server.pike
/usr/roxen/server/etc/modules/RoxenRPC.pmod/HTTP.pmod/Client.pike
/usr/roxen/server/etc/modules/RoxenRPC.pmod/HTTP.pmod/Server.pike
/usr/roxen/server/fonts/32/urw_itc_avant_garde-demi-r
/usr/roxen/server/languages
/usr/roxen/server/modules/directories
/usr/roxen/server/modules/examples/fnord.pike
/usr/roxen/server/modules/filesystems
/usr/roxen/server/modules/filters
/usr/roxen/server/modules/graphics
/usr/roxen/server/modules/ldap/ldaptag.pike
/usr/roxen/server/modules/ldap/ldapuserauth.pike
/usr/roxen/server/modules/logging/client_logger.pike
/usr/roxen/server/modules/logging/home_logger.pike
/usr/roxen/server/modules/logging/nologging.pike
/usr/roxen/server/modules/misc
/usr/roxen/server/modules/proxies
/usr/roxen/server/modules/scripting
/usr/roxen/server/modules/tags
/usr/roxen/server/more_modules/bofh.pike
/usr/roxen/server/more_modules/clock.pike
/usr/roxen/server/more_modules/configure.pike
/usr/roxen/server/more_modules/lysator.pike
/usr/roxen/server/nfonts
/usr/roxen/server/old_modules/filters/hostredirect.pike
/usr/roxen/server/old_modules/tags/ximg.pike
/usr/roxen/server/protocols
/usr/roxen/server/roxen-images
/usr/roxen/server/server_templates
/usr/roxen/server/unfinishedmodules
/usr/roxen/server/RunRoxen
/usr/bin/pike-roxen
/usr/doc/roxen-1.3.122/pdf
/usr/doc/roxen-1.3.122/html
%config/etc/rc.d/init.d/roxen
%config/etc/roxen/configurations/Global_Variables.template
%config/etc/roxen/configurations/Host.template
%config/etc/roxen/index.html.template
/home/roxen/html/welcome/*.gif
/usr/roxen/server/configurations
/usr/roxen/logs
/etc/roxen/logs

%files devel
%defattr(-,root,root,0755)
#%dir /usr/roxen/server/lib/pike/include
/usr/roxen/server/etc/include
/usr/roxen/server/lib/pike/include/*.h
/usr/roxen/server/lib/pike/modules/*.so
/usr/roxen/server/include/pike/*


%preun
if [ $1 -eq 0 ]; then	# We're running "rpm -e"
	if [ -x /etc/rc.d/init.d/roxen ]; then
		/etc/rc.d/init.d/roxen stop;
		chkconfig --del roxen;
	fi
	rm -f /etc/rc.d/init.d/roxen;
	rm -rf /var/log/roxen/*;
	rm -rf /etc/roxen;
fi

%post
if [ $1 -eq 1 ]; then	# We're running "rpm -i"
	# Short hint for Admin
	echo "Use https://"`hostname`":13122/ for the administration-interface" > \
		/usr/doc/roxen-1.3.122/readme.txt
	echo "Use http://"`hostname`"/doc/ for manuales" >> \
		/usr/doc/roxen-1.3.122/readme.txt
	echo "Or use the PDF-documents within /usr/doc/roxen-1.3.122/" >> \
		/usr/doc/roxen-1.3.122/readme.txt

    # Install welcome-HTML-page
    cat /etc/roxen/index.html.template \
        | sed -e "s/%HOST%/`hostname`/g" \
        > /home/roxen/html/index.html

	# Install a basic configuration
	cat /etc/roxen/configurations/Global_Variables.template \
		| sed -e "s/%HOST%/`hostname`/g" \
		> /etc/roxen/configurations/Global_Variables
	chmod u=rw,g=r,o= \
		/etc/roxen/configurations/Global_Variables

	cat /etc/roxen/configurations/Host.template \
		| sed -e "s/%HOST%/`hostname`/g" \
		> /etc/roxen/configurations/`hostname`
	chmod u=rw,g=r,o= \
		/etc/roxen/configurations/`hostname`

    # Delete templates
	rm -f /etc/roxen/configurations/*.template

    # Add Roxen in according Runlevels
	chkconfig --add roxen

elif [ $1 -gt 1 ]; then	# We're running "rpm -U"
	/etc/rc.d/init.d/roxen status 2>&1 > /dev/null
	if [ $? -eq 0]; then
		/etc/rc.d/init.d/roxen restart
	fi
fi

%changelog
* Tue Sep 19 2000 Frederic Lepied <flepied@mandrakesoft.com> 1.3.122-8mdk
- rebuilt to fix wrong dependency of roxen-devel.

* Mon Aug 07 2000 Frederic Lepied <flepied@mandrakesoft.com> 1.3.122-7mdk
- automatically added BuildRequires

* Tue Jul 25 2000 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.3.122-6mdk
- BM, _spechelper_ (who do i've to kill ?)
- split out -devel package
- fix buggy find which make 1 billion fork()

* Fri May 26 2000 Adam Lebsack <adam@mandrakesoft.com> 1.3.122-5mdk
- vaarg patch for ppc

* Wed Apr 19 2000 dam's <dam's@mandrakesoft.com> 1.3.122-4mdk
- changed icon

* Tue Mar 28 2000 Pixel <pixel@mandrakesoft.com> 1.3.122-3mdk
- new group
- rebuild for new readline

* Wed Mar 22 2000 Maurizio De Cecco <maurizio@mandrakesoft.com>
- Adapted to the new Group structure
- Fixed the rpm with respect to the new spec-helper script

* Wed Jan 19 2000 Lenny Cartier <lenny@mandrakesoft.com>
- v 1.3.122
- used srpm provided by Oliver Schade <os@ls-la.net>

* Mon Jan 03 2000 Oliver Schade <os@ls-la.net>
- Added patch for wizard.pike, now handles IE better

* Mon Dec 20 1999 Oliver Schade <os@ls-la.net>
- Updated to new Roxen 1.3rel3 (1.3.122)
- Configuration Port moved to 13122

* Sat Dec 18 1999 Oliver Schade <os@ls-la.net>
- Added a welcome-page demonstrating the major advantages of Roxen

* Mon Nov 29 1999 Lenny Cartier <lenny@mandrakesoft.com>
- New in contribs
- bz2 archive

* Mon Oct 18 1999 Oliver Schade <os@ls-la.net>
- Ooops, the spec-file did not included the templates :-((

* Sun Oct 17 1999 Oliver Schade <os@ls-la.net>
- Enabled cgi-bin-module (Ooooops)

* Sat Oct 16 1999 Oliver Schade <os@ls-la.net>
- Changed prefix from /usr/roxen -> /usr
- Added striping of roxen/server/bin
- Changing of roxen_prefix within pike-roxen added

* Fri Oct 15 1999 Oliver Schade <os@ls-la.net>
- Updated to new Roxen-1.3r2 (1.3.121) release
- Deleted modifcations and CVS-specific compile-instructions.
- HTML- and PDF-documentation moved to /usr/doc/roxen-X.X.XXX
- make -j2 does not work again
- Used %preun and %post from Stefan Siegel <siegel@informatik.uni-kl.de>

* Sat Oct 09 1999 Oliver Schade <os@ls-la.net>
- Included both PDF- and HTML-documentation
- Added preconfigured 'Global-Variables'
- Added welcome-page using some of Roxen's featues.

* Sat Oct 02 1999 Oliver Schade <os@ls-la.net>
- Build a source-package based on CVS-versions
- Modified spec-file after failed experiments
- make -j2 works with CVS-tree

* Wed Sep 22 1999 Oliver Schade <os@ls-la.net>
- First spec-file, just compiles anything
  Do not use 'make -j x', it would not work!
